<?php


/*
    -author: Hiroshi Mito
    -file: index-textcache.php
    -plugin name: Wordpress Text Cache Controller
    -updated: 2014-03-27

    this is a page caching system for wordpress inspired by jeedo aquino.

    if you can use a redis server ,don't use this plugin.Let's enjoy jeedo's chaching system.
      In English
      see more here: http://www.jeedo.net/lightning-fast-wordpress-with-nginx-redis/

      In Japanese
      see more here: http://beautifulajax.dip.jp/?p=667


    if you cannot use a redis server, this plugin is probably useful.

    How to Use
    - cached pages do not expire not unless explicitly deleted or reset
    - appending a ?clear=all or &clear=all to a url deletes the entire cache of the domain, only works when you are logged in
    - appending a ?clear=page or &clear=page to a url deletes the cache of that url
    - script still works even if allow_fopen is disabled
    - submitting a comment deletes the cache of that page
    - refreshing (F5) a page deletes the cache of that page
    - cached pages that locked with password, So don't use this for a critical purpose.


    How to Install

    for setup and configuration see more here:

    In English
    http://beautifulajax.dip.jp/?p=732

    In Japanese
    http://beautifulajax.dip.jp/?p=743


    use this script at your own risk. 


    Change Log
    2014/03/27   Version 0.80 Release.
*/




$plugindir = dirname( __FILE__ ) . "/wp-content/plugins/text-cache-controller/";

if ( file_exists($plugindir . "textcachecontroller.php") ) {
	require_once( $plugindir . "textcachecontroller.php");
}
else{
	//if This plugin was uninstalled ,but this file still used.
	require( dirname( __FILE__ ) . "/original_index.php" );
	return;
}		




$tcc = new TextCacheController();


try{

	$ret = $tcc->tryCache();


	if ($ret["code"] == 0){
		require( dirname( __FILE__ ) . "/original_index.php" );

		$tcc->logEnd("This request is Forward to Wordpress(Normal Wordpress)");
	}
	else if ($ret["code"] == 1){
		ob_start();

		require( dirname( __FILE__ ) . "/original_index.php" );

		$html = ob_get_contents();

		ob_end_clean();
		echo $html;

		$tcc->writeCache($html);

		$tcc->logEnd("This request is Forward to Wordpress(with Creating CACHE)");

	}
	else{
		//return Cache
		define("WP_USE_THEMES", true);
		echo $ret["html"];
		$tcc->logEnd("This response is using CACHE!!");
	}


}
catch(Exception $ex){

	require( dirname( __FILE__ ) . "/original_index.php" );

	try{
		$tcc->logEnd("This request is Forward to Wordpress(Normal Wordpress)");
		$tcc->logEx($ex);
	}
	catch (Exception $ex2){
		//ignore
	}
}




?>