<?php
/*

Plugin Name:  Text Cache Controller
Plugin URI:   http://beautifulajax.dip.jp/?tag=textcachecontroller
Description:  This is a page caching system for Wordpress,This plugin increase WordPress Performance Up To 1,000% — 100,000%(This score is not joke.) This plugin is written for users who cannot install a Redis on the Server hosting Wordpress.See more,please visit my blog!
Version:      0.8.0
Author:       Hiroshi Mito
Author URI:   http://beautifulajax.dip.jp
License:      MIT
Others:       if your environment can use Redis Server,don't use this plugin.
              Let's enjoy jeedo's chaching system.
              In English 
              see more here: http://www.jeedo.net/lightning-fast-wordpress-with-nginx-redis/

              In Japanese
              see more here: http://beautifulajax.dip.jp/?p=667
Text Domain: text-cache-controller
Domain Path: /languages
*/

if ( file_exists(dirname( __FILE__ ) . "/textcachelogger.php") ) {
	require_once( dirname( __FILE__ ) . "/textcachelogger.php");
}

if ( file_exists(dirname( __FILE__ ) . "/textcachesettingcontroller.php") ) {
	require_once( dirname( __FILE__ ) . "/textcachesettingcontroller.php");
}		



class TextCacheControllerAdmin {
	const DOMAIN = "text-cache-controller";

	function __construct() {
		load_plugin_textdomain(self::DOMAIN, false, basename( dirname( __FILE__ ) ).'/languages' );
		add_action("admin_menu", array($this, "add_pages"));
	}
	
	function add_pages() {
		//add_menu_page("TextCache","TextCache",  "level_8", __FILE__, array($this,"show_text_option_page"), "", 26);
		add_submenu_page("options-general.php","Text Cache Controller Settings"
				,"Text Cache Controller",  "level_8", __FILE__, array($this,"showOptions"), "", 26);

	}

	function showOptions() {
		$opts = array();

		//$_POST["tcc_options"]) is Exist?
		if ( isset($_POST["tcc_options"])) {
			check_admin_referer("tcc_options");
			$opts = $_POST["tcc_options"];

			$siteurl = get_option("siteurl");

			/*
			foreach ($opts as $key => $value){
				echo $key . "--" . $value . "\n";
			}
			*/

			if (array_key_exists("save", $opts)){
				$dispMsg = "";
				$ret = $this->saveSettings($opts);
				if ($ret["status"] == true){
					$dispMsg = __("Settings saved.", self::DOMAIN);
				}
				else {
					$dispMsg = __("Settings are ", self::DOMAIN) . "<span class='tcc-alert'>" . __("not saved", self::DOMAIN) . "</span><br />";
					$dispMsg = $dispMsg . $ret["message"];
				}
				
			?>
				<div class="updated fade">
					<p><strong><?php echo $dispMsg; ?></strong></p>
				</div>

			<?php

			}
			else if (array_key_exists("clearall", $opts)){
			?>
				
				<div class="updated fade">
					<p><strong><?php _e("Caches cleared.", self::DOMAIN); ?></strong></p>
				</div>
			<?php
			}
			else if (array_key_exists("recreateall", $opts)){
				$ret = $this->createReCacheHtml($opts);
				if ($ret["status"] == true){
					$recreateUrl = $siteurl . "/wp-content/plugins/text-cache-controller/create-cache.php?seckey=" . $ret["message"];
				}
				else{
					$recreateUrl = __("Something went wrong, please check the log file of this plugin", self::DOMAIN);	
				}
			}

			
		}
		?>

		<span id="wp_siteurl" style="display:none;"><?php echo $siteurl; ?></span>

		<script type="text/javascript" >
			jQuery(document).ready(function($) {

				function clearCache(){
					if ($("span.tcc-clearall").size() == 0){
						return;
					}

					var reqUrl = $("#wp_siteurl").text() + "/?clear=all";
					//alert(reqUrl);

					$.ajax({
						type: "GET",
						url: reqUrl,
						async: true,
						dataType: "html",
						data: "",
						success: function(data, dataType){
						 	
						},
						error :function(XMLHttpRequest, textStatus, errorThrown){
							//alert("Something went wrong.");
						}
					});
				}


				clearCache();
			});
		</script>


		<div class="wrap">
			<div id="icon-options-general" class="icon32"><br /></div>
			<h2>Settings for Text Cache Controller</h2>
			<form action="" method="post">

			<?php
				wp_nonce_field("tcc_options");
				$opt_controllername = get_option("tcc_controllername");
				$opt_isdebug = get_option("tcc_isdebug");
				$opt_timezone = get_option("timezone_string");

				if ($opt_controllername == ""){
					$opt_controllername = "tcc";
				}
				if ($opt_isdebug == ""){
					$opt_isdebug = false;
				}
				if ($opt_timezone == ""){
					$opt_timezone = "UTC";
				}

				$show_text = isset($opt["text"]) ? $opt["text"]: null;
			?> 
				<div class="tcc-table">
					<div class="header">
						<span><?php _e("General Settings", self::DOMAIN); ?></span>
					</div>
					<div class="row">
						<div class="caption">
							<label><?php _e("Controller Name", self::DOMAIN); ?></label>
						</div>
						<div class="data">
							<input name="tcc_options[controllername]" type="text" id="tcc_controllername" 
								value="<?php  echo $opt_controllername; ?>" class="regular-text" />

							<br />
							<span>
								<?php _e("Specify the minimum capability required to configure Text Cache Controller (default: tcc). This name is used as directory name of cache files and log.", self::DOMAIN); ?>
							</span>
						</div>
						<div class="clear"></div>
						<div class="caption">
							<label><?php _e("Run Mode", self::DOMAIN); ?></label>
						</div>
						<div class="data">
							<select name="tcc_options[isdebug]" id="tcc_isdebug">
							<?php
								$dbgoptions = array(
									array("value" => "false", "text"=>"Normal"),
									array("value" => "true", "text"=>"Debug")
								);
								foreach ($dbgoptions as $opt) : 
							?>
									<option value="<?php echo $opt["value"]; ?>"
										<?php 
											if($opt_isdebug == $opt["value"]){
												 echo " selected='selected'"; 
											} 
										?>
										>
										<?php echo $opt["text"]; ?>
									</option>
							<?php 
								endforeach; 
							?>
							
							</select>
							<br />
							<span>
								<?php _e("if this plugin does not propery function, please set this option to Debug. Then this plugin output detail information to Log File(tcc.log).", self::DOMAIN); ?>
							</span>
						</div>
						<div class="clear"></div>
						<div class="caption">
							<label><?php _e("Timezone", self::DOMAIN); ?></label>
						</div>
						<div class="data">
							<input name="tcc_options[timezone]" type="text" id="tcc_timezone" 
								value="<?php  echo $opt_timezone; ?>" readonly="readonly" class="regular-text" />

							<br />
							<span>
								<?php _e("Timezone of Wordpress common settings.This value is using in log output.", self::DOMAIN); ?>
							</span>
						</div>
						<div class="clear"></div>
					</div>

				</div>
				<div class="tcc-submit">
					<input type="submit" name="tcc_options[save]" class="button-primary" value="<?php _e("Save Changes", self::DOMAIN); ?>" />
				</div>
			</form>
					
					
			<form action="" method="post">
			<?php
				wp_nonce_field("tcc_options");
			?>
				<div class="tcc-table">
					<div class="header">
						<span><?php _e("Cache Control", self::DOMAIN); ?></span>
					</div>
					<div class="row">

						<div class="caption">
							<label><?php _e("Clear All Caches", self::DOMAIN); ?></label>
						</div>
						<div class="data">
							<input name="tcc_options[clearall]" type="submit" id="tcc_clearall" 
								class="button-primary" value="<?php _e("Clear All", self::DOMAIN); ?>" />

							<br />
							<span>
								<?php _e("Clear all CACHE files in cache directory except log file(tcc.log).", self::DOMAIN); ?>
							</span>

							<?php
							if (array_key_exists("clearall", $opts)){
								echo "<span class='tcc-clearall'>&nbsp;</span>";
							}
							?>

						</div>
						<div class="clear"></div>

						<div class="caption">
							<label><?php _e("Re-Create All Caches", self::DOMAIN); ?></label>
						</div>
						<div class="data">
							<input name="tcc_options[recreateall]" type="submit" id="tcc_clearall" 
								class="button-primary" value="<?php _e("Re-Create Caches", self::DOMAIN); ?>" />

							<br />
							<span>
								<?php _e("Re-create CACHE files for available URI of your site.", self::DOMAIN); ?>
							</span>
							<br />
							<label><?php _e("Start(Recent Post = 1)", self::DOMAIN); ?></label>
							<select name="tcc_options[recreate-start]" >
								<option value="1" selected="selected">1</option>
								<?php
									for ($i = 1 ; $i < 50 ; $i++){
										echo '<option value="' . $i . '01">' . $i . '01</option>';
									}
								?>
							</select>
							<label><?php _e("Count", self::DOMAIN); ?></label>
							<select name="tcc_options[recreate-count]" >
								<option value="10">10</option>
								<option value="30">30</option>
								<option value="50">50</option>
								<option value="100" selected="selected">100</option>
								<option value="200">200</option>
								<option value="300">300</option>
								<option value="400">400</option>
								<option value="500">500</option>
							</select>

							<?php
							if (array_key_exists("recreateall", $opts)){
							?>
							<div class="updated-copy">
								<p><strong>
									<?php 
										$msg = "<span class='tcc-alert'>" . _e("For re-create CHACES", self::DOMAIN) . "</span>,";
										$msg = $msg . _e(" Access this url with a browser that is ", self::DOMAIN) . "<span class='tcc-alert'>" . _e("not loggined.", self::DOMAIN) . "</span>";
										$msg = $msg . _e("(Ex-- Private Browse)", self::DOMAIN) . "<br />";
										$msg = $msg . "<a href='" . $recreateUrl . "'>" . $recreateUrl . "</a>";
										_e($msg); 
									?>
								</strong></p>
							</div>
							<?php
							}
							?>

						</div>
						<div class="clear"></div>


					</div>
				</div>
			</form>

			<div class="tcc-table">
				<div class="header">
					<span><?php _e("How to install", self::DOMAIN); ?></span>
				</div>
				<div class="row">
					<div class="desc">
						<div class="updated-copy">
							<strong>
							<?php echo $this->checkInstallStatus(); ?>
							</strong>
						</div>
					</div>

					<div class="desc">
						<span>
							<?php _e("How to install this plugin into your Wordpress site.", self::DOMAIN); ?>
						</span>
					</div>
					<div class="desc">
						<span>
							<ul class="tcc-normal-ul">
								<li><?php _e("WORDPRESS_ROOT >> Wordpress installed directory", self::DOMAIN); ?> </li>
								<li><?php _e("Copy index.php which is in WORDPRESS_ROOT to original_index.php.", self::DOMAIN); ?></li>
								<li><?php _e("Copy index-textcache.php which is in this plugin directory to WORDPRESS_ROOT/index.php.", self::DOMAIN); ?></li>
							</ul>
							<div class="tcc-code">
								<div> $ cd WORDPRESS_ROOT</div>
								<div> $ cp index.php original_index.php</div>
								<div> $ cp wp-content/plugins/text-cache-controller/index-textcache.php index.php</div>
							</div>

						</span>
					</div>					
					<div class="desc">
						<span>
							<?php _e("For more information ,you need. Please check", self::DOMAIN); ?>
							<a href="http://beautifulajax.dip.jp/?tag=textcachecontroller">my Blog.</a>
						</span>
					</div>
					<div class="clear"></div>
				</div>
			</div>


		</div><!-- /.wrap -->

	<?php
	}


	private function createReCacheHtml($opts){
		$str = "";
		$tmpl = '<div class="post"><div class="postid">@id</div>';
		$tmpl =  $tmpl . '<div class="posttitle" uri="@uri" id="post-@id" >@title</div>';
		$tmpl =  $tmpl . '<div class="complete" id="complete-post-@id">no</div>';
		$tmpl =  $tmpl . '<div class="clearfix"></div></div>';
		
		$count = 100;
		$start = 0;
		if (array_key_exists("recreate-count", $opts)){
			$count = intval($opts["recreate-count"]);
		}
		if (array_key_exists("recreate-start", $opts)){
			$start = intval($opts["recreate-start"]) -1;
		}

		$args = array(
			'numberposts' => $count,
			'offset' => $start);

		$recent_posts = wp_get_recent_posts($args);

		foreach($recent_posts as $post){
			$wk = str_replace("@id", $post["ID"], $tmpl);
			$wk = str_replace("@uri", get_permalink($post["ID"]) , $wk);
			$wk = str_replace("@title", $post["post_title"] , $wk);

			$str = $str . $wk . "\n";
		} 		

		$tmpl2 = '<div class="post"><div class="postid">@id</div>';
		$tmpl2 =  $tmpl2 . '<div class="posttitle" uri="@uri" id="cat-@id" >@title</div>';
		$tmpl2 =  $tmpl2 . '<div class="complete" id="complete-cat-@id">no</div>';
		$tmpl2 =  $tmpl2 . '<div class="clearfix"></div></div>';
		$categories = get_categories( 'get=all' ); 

		$strCat = "";
		foreach($categories as $cat){
			$link = get_category_link( $cat->term_id );
			$wk = str_replace("@id", $cat->term_id, $tmpl2);
			$wk = str_replace("@uri", $link , $wk);
			$wk = str_replace("@title", $cat->name , $wk);

			$strCat = $strCat . $wk . "\n";
		}

		$tmpl3 = '<div class="post"><div class="postid">@id</div>';
		$tmpl3 =  $tmpl3 . '<div class="posttitle" uri="@uri" id="tag-@id" >@title</div>';
		$tmpl3 =  $tmpl3 . '<div class="complete" id="complete-tag-@id">no</div>';
		$tmpl3 =  $tmpl3 . '<div class="clearfix"></div></div>';
		$tags = get_tags( 'get=all' ); 

		$strTag = "";
		foreach($tags as $tag){
			$link = get_tag_link( $tag->term_id );
			$wk = str_replace("@id", $tag->term_id, $tmpl3);
			$wk = str_replace("@uri", $link , $wk);
			$wk = str_replace("@title", $tag->name , $wk);

			$strTag = $strTag . $wk . "\n";
		}

		$siteurl = get_option("siteurl");

		$tmpl4 = '<div class="post"><div class="postid">@id</div>';
		$tmpl4 =  $tmpl4 . '<div class="posttitle" uri="@uri" id="top-@id" >@title</div>';
		$tmpl4 =  $tmpl4 . '<div class="complete" id="complete-top-@id">no</div>';
		$tmpl4 =  $tmpl4 . '<div class="clearfix"></div></div>';
		

		$strTop = "";
		$wk = str_replace("@id", "1", $tmpl4);
		$wk = str_replace("@uri", $siteurl , $wk);
		$wk = str_replace("@title", "Top Page" , $wk);
		$strTop = $strTop . $wk . "\n";

		for($i = 2 ; $i <= 5 ; $i++){
			$link = $siteurl . "/?paged=";
			$wk = str_replace("@id", $i, $tmpl4);
			$wk = str_replace("@uri", $link . $i , $wk);
			$wk = str_replace("@title", "Page " . $i , $wk);

			$strTop = $strTop . $wk . "\n";
		}



		$isdebug = get_option("tcc_isdebug");
		$dirname = get_option("tcc_controllername");

		$logger = $this->createLogger();

		$ret = $this->replaceReCacheHtml($str, $strCat, $strTag, $strTop, $logger);

		return $ret;
	}

	private function replaceReCacheHtml($writeLines, $writeLinesCat, $writeLinesTag, $writeLinesTop, $logger){
		$ret["status"] = false;
		$lineArr = array();

		$fname = dirname(__FILE__) . "/create-cache.html.template";

		$handle = $logger->openHandle($fname, "r");

		if ($handle == false) {
			$msg = "Create ReCache Html Failure: Cannot open create-cache.html.tmplete";
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			return $ret;
		}


		try{
			while (! feof ($handle)) {
				$line = fgets ($handle, 4096);
				$lineArr[] = $line;   
			}

			fclose ($handle);
		}
		catch(Exception $ex){
			$msg = "Create ReCache Html Failure: While read create-cache.html.tmplete";
			$msg = $msg . $ex->getMessage();
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			try {
				fclose ($handle);
			}
			catch (Exception $ex){
				//ignore
			}

			return $ret;
		}


		foreach (glob(dirname(__FILE__) . "/create-cache.php") as $tfile) { 
		    unlink($tfile);
		}

		$securekey = substr(md5(substr(microtime(),-5)),-10);
		$fname = dirname(__FILE__) . "/create-cache.php";

		$handle = $logger->openHandle($fname, "w");

		if ($handle == false) {
			$msg = "Create ReCache Html Failure: Cannot open create-cache.php";
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			return $ret;
		}


		try{
			for ($i = 0 ; $i < count($lineArr) ; $i++){
				if (strpos($lineArr[$i],"@@@INSERT@@@") !== false){
					$lineArr[$i] = str_replace("@@@INSERT@@@", $writeLines, $lineArr[$i]);
				}

				if (strpos($lineArr[$i],"@@@INSERT-CAT@@@") !== false){
					$lineArr[$i] = str_replace("@@@INSERT-CAT@@@", $writeLinesCat, $lineArr[$i]);
				}

				if (strpos($lineArr[$i],"@@@INSERT-TAG@@@") !== false){
					$lineArr[$i] = str_replace("@@@INSERT-TAG@@@", $writeLinesTag, $lineArr[$i]);
				}

				if (strpos($lineArr[$i],"@@@INSERT-TOP@@@") !== false){
					$lineArr[$i] = str_replace("@@@INSERT-TOP@@@", $writeLinesTop, $lineArr[$i]);
				}

				if (strpos($lineArr[$i],"@@@SECKEY@@@") !== false){
					$lineArr[$i] = str_replace("@@@SECKEY@@@", $securekey, $lineArr[$i]);
				}

				if (fwrite($handle,  $lineArr[$i]) === FALSE){
					$msg = "Create ReCache Html Failure: While write create-cache.php";
					$ret["status"] = false;
					$ret["message"] = $msg;
					$logger->log($msg);				

					fclose($handle);
					return $ret;
				}
			}

			fclose($handle);

		}
		catch(Exception $ex){
			$msg = "Create ReCache Html Failure: While read create-cache.php";
			$msg = $msg . $ex->getMessage();
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			try {
				fclose ($handle);
			}
			catch (Exception $ex){
				//ignore
			}

			return $ret;
		}


		$ret["status"] = true;
		$ret["message"] = $securekey;

		return $ret;
	}

	function checkInstallStatus(){
		$wp_root = dirname(dirname(dirname(dirname(__FILE__))));

		$rtn = "";
		if (file_exists($wp_root . "/original_index.php") == false){
			$rtn = "<span class='tcc-alert'>" . __("Installation is not complete.", self::DOMAIN) . "</span><br />";
			$rtn = $rtn . "<span>" . __("original_index.php is not exist in Wordpress root directory.", self::DOMAIN) . "</span>";
			return $rtn;
		}

		if (file_exists($wp_root . "/index.php") == false){
			$rtn = "<span class='tcc-alert'>" . __("Installation is not complete.", self::DOMAIN) . "</span><br />";
			$rtn = $rtn . "<span>" . __("index.php is missing in Wordpress root directory.", self::DOMAIN) . "</span>";
			return $rtn;
		}

		if ($this->checkMyPlugin($wp_root . "/index.php") == false ){
			$rtn = "<span class='tcc-alert'>" . __("Installation is not complete.", self::DOMAIN) . "</span><br />";
			$rtn = $rtn . "<span>" . __("index.php which is in Wordpress root directory is not matched Text Cache Controller.", self::DOMAIN) . "</span>";
			return $rtn;
		}

		return "<span class='tcc-ok'>" . __("Installation is complete.", self::DOMAIN) . "</span><br />";

	}

	function checkMyPlugin($fname){
		$ret = false;

		$logger = $this->createLogger();
		$logger->log("Cehck Installation: Start");
		
		$lineArr = array();

		$handle = $logger->openHandle($fname, "r");

		if ($handle == false) {
			$msg = "Cehck Installation Failure: Cannot open index.php";
			$logger->log($msg);

			return $ret;
		}

		try{
			while (! feof ($handle)) {
				$line = fgets ($handle, 4096);

				if (strpos($line,"Hiroshi Mito") !== false){
					$ret = true;
					break;
				}
			}

			fclose ($handle);
		}
		catch(Exception $ex){
			$msg = "Cehck Installation Failure: While read index.php";
			$msg = $msg . $ex->getMessage();
			$logger->log($msg);

			try {
				fclose ($handle);
			}
			catch (Exception $ex){
				//ignore
			}

			return $ret;
		}

		$logger->log("Cehck Installation: End");

		return $ret;
	}


	function saveSettings($opts){
		$ret["status"] = false;

		$ctlname = $opts["controllername"];
		$isdebug = $opts["isdebug"];
		$tz = $opts["timezone"];

		if (!(preg_match("/^[a-zA-Z0-9]+$/", $ctlname))){
			$ret["message"] = __("Controller Name : Numeric or Alpha only!", self::DOMAIN);
			return $ret;
		}

		if (!($isdebug == "true" || $isdebug == "false")){
			$isdebug = "false";
		}

		$logger = $this->createLogger();
		$logger->log("Save Settings: Start");

		update_option("tcc_controllername", $ctlname);
		update_option("tcc_isdebug", $isdebug);

		$opts2["TCC_DIRNAME"] = $ctlname;
		$opts2["TCC_ISDEBUG"] = $isdebug;
		$opts2["TCC_TIMEZONE"] = $tz;
		
		$setController = new TccSettingController();
		$setController->writeOptions($opts2, $logger);

		$this->mkdir(dirname(__FILE__) . "/" . $ctlname, $logger);

		$logger->log("Save Settings: End");

		$ret["status"] = true;
		return $ret;

	}

    private function mkdir($dirname, $logger){
    	if (is_dir($dirname)){
			$logger->debug("Make Directory: is_dir(" . $dirname . ")");

    			return true;
    		}

    		if (mkdir($dirname)) {
			$logger->debug("Make Directory Complete: mkdir(" . $dirname . ")");
			return true;
		} 
		else {
			$msg = __("create directory failure ,please check permission of ", self::DOMAIN) . $dirname ;
			$msg = $msg . __(" or check error log of apache or nginx ", self::DOMAIN);

			$logger->log($msg);
			$logger->debug("Make Directory Failure: mkdir(" . $dirname . ")");
			return false;
		}
    }	

	private function createLogger(){

		$ctlname = get_option("tcc_controllername");
		$isdebug = get_option("tcc_isdebug");

		$logger = new TextCacheLogger($ctlname, $isdebug);


		return $logger;
	}

	public function test(){
		$logger = $this->createLogger();

		$tstOptions["TCC_DIRNAME"] = "tcc";
		$tstOptions["TCC_ISDEBUG"] = "false";
		$tstOptions["TCC_TIMEZONE"] = "Asia/Tokyo";
		
		$setController = new TccSettingController();
		$setController->writeOptions($tstOptions, $logger);
		//$setController->execInstall($logger);
	}
}

function tcc_styles() {
    wp_register_style( 'custom_wp_admin_css', plugins_url('text-cache-controller/text-cache-controller.css'));
    wp_enqueue_style( 'custom_wp_admin_css' );
}
add_action('admin_enqueue_scripts', 'tcc_styles');

function tcc_scripts() {
	wp_enqueue_script( 'jquery' );
}

add_action('wp_enqueue_scripts','tcc_scripts');

$tccadmin = new TextCacheControllerAdmin();

//$tccadmin->test();

?>