<?php 


class TccSettingController{

	public function __construct(){
		//echo TCC_TIMEZONE;
		//echo TCC_DIRNAME;
	}
	public function getOptions(){


	}

	public function writeOptions($options, $logger){
		$logger->debug("Write options: Start");

		$source = dirname( __FILE__ ) . "/settings.php";
		$dest = dirname( __FILE__ ) . "/backup_settings.php";

		$ret = $this->copyFile($source, $dest, "settings.php" , "backup_settings.php", $logger);
		if ($ret["status"] == false){
			return $ret;
		}


		$ret = $this->readAll($source, $logger);
		if ($ret["status"] == false){
			return $ret;
		}
		$lineArr = $ret["lines"];

		$removed = false;
		for ($i = 0 ; $i < 5 ; $i++){
			if (unlink() == true){
				$removed = true;
				break;
			}
			usleep(500000); //1000000 = 1sec
		}

		if ($removed == fale){
			$msg = "Write Options Failure: Cannot delete settings.php";
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			return $ret;
		}

		//Replace Settings
		$newArr = array();
		$newArr[] = "<?php\n";

		for ($i = 0 ; $i < count($lineArr); $i++){
			if ($this->checkOption($options, $lineArr[$i]) == false){
				$newArr[] = $lineArr[$i];
			}
		}
		$newArr[] = "?>\n";

		foreach ($options as $key => $value){
			$line = "define('" . $key . "', '" . $value . "');\n";
			array_splice($newArr, 1, 0, $line);
		}


		$handle = $logger->openHandle($source, "w");

		if ($handle === FALSE) {
			$msg = "Write Options Failure: Cannot open(w) settings.php";
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			$this->copyFile($dest, $source, "backup_settings.php" , "settings.php", $logger);

			return $ret;
		}

		try{

			for ($i = 0 ; $i < count($newArr) ; $i++){
				if (fwrite($handle,  $newArr[$i]) === FALSE){
					$msg = "Write Options Failure: While write settings.php  ";
					$ret["status"] = false;
					$ret["message"] = $msg;
					$logger->log($msg);				

					fclose($handle);
					return $ret;
				}
			}

			fclose($handle);
		}
		catch(Exception $ex){
			$msg = "Write Options Failure: While write settings.php  ";
			$msg = $msg . $ex->getMessage();
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			try {
				fclose ($handle);
			}
			catch (Exception $ex){
				//ignore
			}

			$this->copyFile($dest, $source, "backup_settings.php" , "settings.php", $logger);

			return $ret;
		}

		$logger->debug("Write options: End");

		$ret["status"] = true;
		$ret["message"] = "";

		return $ret;
	}

	private function checkOption($options, $line){
		foreach($options as $key => $value){
			$pos1 = strpos($line, $key);
			$pos2 = strpos($line, "define");
			$pos3 = strpos($line, "//");

			if ( $pos1 !== false && $pos2 !== false){
				if ($pos3 === false){
					return true;
				}
				else if ($pos1 > $pos3){
					return true;
				}
			}
		}

		return false;
	}

	private function readAll($fname, $logger){
		$ret["status"] = false;
		$lineArr = array();

		$handle = $logger->openHandle($fname, "r");

		if ($handle == false) {
			$msg = "Write Options Failure: Cannot open settings.php";
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			return $ret;
		}


		try{
			while (! feof ($handle)) {
				$line = fgets ($handle, 4096);

				if (! (strpos($line,"<?php") === false) ){
					continue;
				}
				if (! (strpos($line,"?>") === false) ){
					continue;
				}
				$lineArr[] = $line;   
			}

			fclose ($handle);
		}
		catch(Exception $ex){
			$msg = "Write Options Failure: While read settings.php  ";
			$msg = $msg . $ex->getMessage();
			$ret["status"] = false;
			$ret["message"] = $msg;
			$logger->log($msg);

			try {
				fclose ($handle);
			}
			catch (Exception $ex){
				//ignore
			}

			return $ret;
		}

		$ret["status"] = true;
		$ret["lines"] = $lineArr;

		return $ret;
	}

	private function copyFile($source, $dest,$sourceShort,$destShort,$logger){
		$rtn["status"] = false;
		$rtn["message"] = "";

		$copied = false;
		for ($i = 0 ; $i < 5 ; $i++){
			if (copy($source, $dest)) {
				$copied = true;
				break;
			}
			usleep(500000); //1000000 = 1sec
		}

		if ($copied = false){
			$rtn["message"] = "Cannot copy " . $sourceShort. " to " . $destShort;
			$logger.log($rtn["message"]);
			return $rtn;
		}		

		$rtn["status"] = true;
		return $rtn;
	}
}

?>
